//+------------------------------------------------------------------+
//|                                     Ehlers  Center of Gravity.mq4|
//+------------------------------------------------------------------+ 

//
//
//
//
//

#property  copyright "www.forex-tsd.com"
#property  link      "www.forex-tsd.com"

//
//
//
//
//

#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  DeepSkyBlue
#property  indicator_color2  PaleVioletRed

//
//
//
//
//
 
extern int  Per            = 10;
extern int  Price          = PRICE_MEDIAN;
extern bool showSignalLine = true;

//
//
//
//
//

double buf1[];
double buf2[];
double pr[];
   
//+----------------------------------------------------------+
//|                                                          |
//+----------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
      SetIndexBuffer(0,buf1);
      SetIndexBuffer(1,buf2);
      SetIndexBuffer(2,pr);
      
      //
      //
      //
      //
      //
      
   IndicatorShortName("Ehlers Center of gravity ("+Per+")");
   return(0);
}

//+----------------------------------------------------------+
//|                                                          |
//+----------------------------------------------------------+
//
//
//
//
//

int deinit(){return(0);}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int  counted_bars=IndicatorCounted();
   int  i,limit;

   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = Bars-counted_bars;

   //
   //
   //
   //
   //
         
   for(i=limit; i>=0; i--)
   {  
         pr[i] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
      double n = 0;
      double d = 0;
      
      //
      //
      //
      //
      //

      for (int k=0; k<Per; k++)
      {
      n += pr[i+k]*(k+1);
      d += pr[i+k];
      }               

      // 
      //
      //
      //
      //

      if (d !=0)
            buf1[i] = -n/d;
      else  buf1[i] = 0; 
            
      if (showSignalLine)
            buf2[i] = buf1[i+1];
      
      //
      //
      //
      //
      //
            
      } 
           
   return(0);
  }
//+------------------------------------------------------------------+